<?php
/**
 * DBShop 电子商务系统
 *
 * ==========================================================================
 * @link      https://www.dbshop.net/
 * @copyright 北京珑大钜商科技有限公司，并保留所有权利。
 * @license   https://www.dbshop.net/license.html License
 * ==========================================================================
 *
 * @author    静静的风 <baron@loongdom.cn>
 *
 */

namespace Goods\Event\Factory;

use Admin\Data\Config;
use Goods\Event\GoodsListener;
use Goods\Service\GoodsConsultationManager;
use Goods\Service\GoodsInSpecImageManager;
use Goods\Service\GoodsInTagManager;
use Goods\Service\GoodsSpecTagGoodsManager;
use Goods\Service\GoodsSpecTagManager;
use Interop\Container\ContainerInterface;
use Laminas\ServiceManager\Factory\FactoryInterface;

class GoodsListenerFactory implements FactoryInterface
{
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $entityManager      = $container->get(Config::SHOP_DATABASE_MANAGER_WRITE);
        $goodsInTagManager  = $container->get(GoodsInTagManager::class);
        $goodsInSpecImageManager    = $container->get(GoodsInSpecImageManager::class);
        $goodsConsultationManager   = $container->get(GoodsConsultationManager::class);
        $goodsSpecTagGoodsManager   = $container->get(GoodsSpecTagGoodsManager::class);
        $goodsSpecTagManager        = $container->get(GoodsSpecTagManager::class);

        return new GoodsListener(
            $entityManager,
            $goodsInTagManager,
            $goodsInSpecImageManager,
            $goodsConsultationManager,
            $goodsSpecTagGoodsManager,
            $goodsSpecTagManager
        );
    }
}